#ifndef EBasicAPP
#define EBasicAPP
#include <coecntrl.h>
#include <coeview.h>
#include <eikapp.h>
#include <e32base.h>
//#define UIQ

#include <e32base.h>
_LIT(KOnScreenChars,"ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789abcdefghijklmnopqrstuvwxyz");

#ifdef UIQ
//#include <qikdocument.h>
//class CEBasicDoc:public CQikDocument
#else
#include <eikdoc.h>
class CEBasicDoc:public CEikDocument
#endif
{
public:	
	~CEBasicDoc();
//	static CEBasicDoc* NewL(CEikApplication& aApp);
	virtual CEikAppUi* CreateAppUiL();
	CEBasicDoc(CEikApplication& aApp);

private:
	void ConstructL();
};


class CEBasicView;
#ifdef UIQ
#include <qikappui.h>
//class CEBasicAppUi:public CQikAppUi
#else
#include <eikappui.h>
class CEBasicAppUi:public CEikAppUi
#endif
{
	public:
		CEBasicAppUi();
		~CEBasicAppUi();
		void ConstructL();
		void HandleCommandL(TInt aCommand);
		CEBasicView* View(){return iView;};
		void DoExitNext(){iExitNext=ETrue;};
		void HandleWsEventL(const TWsEvent& aEvent, CCoeControl* aDestination);
		static TInt StaticSDLStartL(TAny* aAppUi);
		void SDLStartL();
		void DrawView();
	private:
		TWsEvent TranslateWsEventL(const TWsEvent& aEvent);

		TBool iExitNext;
		CEBasicView* iView;
		CAsyncCallBack iSDLstart;
		TInt iLastChar;

};




class CEBasicView:public CCoeControl,public MCoeView
{
public:
	CEBasicView();
	~CEBasicView();
	void SetAppUi(TUid aUid){iAppUid=aUid;};
	void ActGc(){ActivateGc();};
	void DeGc(){DeactivateGc();};
	RWindow& Win() const {return Window();};
	void ConstructL(const TRect& aRect);
//	virtual void HandlePointerEventL(const TPointerEvent& aPointerEvent);
//	TKeyResponse OfferKeyEventL(const TKeyEvent& aKeyEvent,TEventCode aType);

	void Draw(const TRect& aRect) const;
	TCoeInputCapabilities InputCapabilities() const;
	void SetInputState(TBool aOnOff);
	TVwsViewId ViewId() const;
	virtual void ViewActivatedL(const TVwsViewId& aPrevViewId,TUid aCustomMessageId,const TDesC8& aCustomMessage);
	virtual void ViewDeactivated();
	void UpdateCharSelector(TInt aLetterOffset);
	void DrawCharSelector(CWindowGc& aGc) const;
	TInt iXOffSet;
#ifdef __WINS__
	CFbsBitmap* iGameScreen;
#endif
	TBool iInputState;
	TDisplayMode iDispMode;         ///< Display mode for screen.
	TUid iAppUid;
	TInt iLetterOffset;

};

#endif