/*******************************************************************
 * SDLRunner.h
 *
 * Author:	Andreas Karlsson (sprawl@onlajn.nu)
 * (c) Copyright 2002, Andreas Karlsson
 * All Rights Reserved
 *
 */

#ifndef __SDL_MAIN_SYMBIAN32_SDLRUNNER_H__
#define __SDL_MAIN_SYMBIAN32_SDLRUNNER_H__

class CSDLRunner : public CActive
{
public:
	static CSDLRunner *NewL();
	~CSDLRunner();


	void RunSDLL();
	void TerminateSDLL();

protected:
	CSDLRunner();
	void ConstructL();

	//Implement CActive
	virtual void RunL();
	virtual void DoCancel();

	//Thread methods...
	static TInt ThreadMain(TAny* aData);
	void DoRunGameL();
	

	RThread	iChild;
};


#endif //__SDL_MAIN_SYMBIAN32_SDLRUNNER_H__
