
#include "QSDLDocument.h"
#include "QSDLUi.h"

CQSDLDocument::CQSDLDocument( CEikApplication &aApplication )
	: CQikDocument( aApplication )
{

}

CQSDLDocument::~CQSDLDocument()
{
	delete iModel;
}

CQSDLDocument *CQSDLDocument::NewL( CEikApplication &aApplication )
{
	CQSDLDocument *self = new(ELeave) CQSDLDocument( aApplication );
	CleanupStack::PushL( self );
	self->ConstructL();
	CleanupStack::Pop(); //self
	return self;
}

void CQSDLDocument::ConstructL()
{
	iModel = CQSDLModel::NewL();
}	

CEikAppUi	*CQSDLDocument::CreateAppUiL()
{
	return new (ELeave) CQSDLUi;
}

CQSDLModel &CQSDLDocument::Model()
{
	return *iModel;
}