#ifndef __OIM_QIK_QOIMUSERVIEW_H__
#define __OIM_QIK_QOIMUSERVIEW_H__


#include <coecntrl.h>
#include <coeview.h>
#include <eiklbo.h>

#include "QSDLListView.h"

class QSDLModel;
class CEikTextListBox;
class CTextListItemDrawer;

// A list view to display the model's users as text

class CQSDLUserListView : public CQSDLListView
{
public:
	static CQSDLUserListView * NewL();
	~CQSDLUserListView ();

	// Implement CQSDLViewBase
	TUid ViewUid() const;

	// Implement CQSDLListView
	void RefreshListBoxL();

	// Implement MCoeView
	void ViewActivatedL(const TVwsViewId& aPrevViewId,
		TUid aCustomMessageId, const TDesC8& aCustomMessage);

	// Implements CCoeControl
	CCoeControl* ComponentControl(TInt aIndex) const;
	TInt CountComponentControls() const;

private:
	void ConstructL();
	CQSDLUserListView();

private:
	// Text list box to display the shape descriptions
	CEikTextListBox* iUserListBox;
	// Descriptor array in which to hold text descriptions of the shapes
	CDesC16ArrayFlat* iStringArray;
};



#endif //__OIM_QIK_QOIMUSERVIEW_H__