// CQSDLViewBase.cpp
// Copyright (c) 2002 Andreas Karlsson

#include <eikenv.h>
#include <eikdoc.h>
#include <qikon.hrh>
#include <qikappui.h>

#include "QSDLViewBase.h"
#include "q_sdl_external_interface.h"
#include "QSDLUi.h"
#include "QSDLDocument.h"
#include "oIM.hrh"

// Stores some useful variables
CQSDLViewBase::CQSDLViewBase()
	{
	iAppUi = STATIC_CAST(CQSDLUi*, iEikonEnv->EikAppUi());
	iModel = &(STATIC_CAST(CQSDLDocument*, iAppUi->Document())->Model());
	iCategoryModel = iAppUi->CategoryModel();
	}

// Returns view's ID
TVwsViewId CQSDLViewBase::ViewId() const 
	{
	return TVwsViewId(KUidSDL, ViewUid());
	}

