/**********
 * Qik Document
 * (c) Copyright 2002 Andreas Karlsson
 */

#ifndef __OIM_QIK_QOIMDOCUMENT_H__
#define __OIM_QIK_QOIMDOCUMENT_H__

#include <qikappui.h>
#include <qikdocument.h>
#include <qikapplication.h>

#include "QSDLModel.h"

class CQSDLDocument : public CQikDocument
{
public:
	CQSDLDocument( CEikApplication &aApplication );
	~CQSDLDocument();

	static CQSDLDocument *NewL( CEikApplication &aApplication );

	CQSDLModel& Model();

private:
	
	void ConstructL();

	CEikAppUi  *CreateAppUiL();

	CQSDLModel *iModel;
};

#endif //__OIM_QIK_QOIMDOCUMENT_H__
